Subject: RE: User Petition on Standards to Netscape and Microsoft

From: "Turner, Randy" <[email-masked]>
Date: Sat, 3 Jan 1998 10:24:30 -0800

I'm assuming by the statement below that you mean a
subset of ASN.1 could make a useful protocol syntax,
and not encoding. ASN.1 and XDR solve two different
problems. Are you comparing BER and XDR perhaps?

Randy

> -----Original Message-----
> From:	[email-masked] [SMTP:[email-masked]]
> Sent:	Saturday, January 03, 1998 9:12 AM
> To:	[email-masked]; [email-masked]
> Subject:	Re: User Petition on Standards to Netscape and Microsoft
> 
> Karl,
> 
> I agree that a subset of ASN.1 could make a useful binary encoding
> format, when binary encoding is necessary.  So could XDR, by the way.
> I would make an even stronger requirement than yours in the
> subsetting.
> First, we should limit the scope of the language to simple data
> structures.
> This means:
> 
> 1) never use the MACRO extension. I think everyone agree on that.
> 
> 2) never use the VALUE notation. This is in fact the source of most
>    bugs in the 1988 version.
> 
> 3) because you don't want to use the VALUE notation, never use the
>    DEFAULT feature.  OPTIONAL and CHOICE can do the job.
> 
> 4) don't even think of using the object oriented notations of 1994.
> 
> Then, I would learn from experience and try to disallow the features
> of ASN.1 that did pose interoperability problems in the past. This
> means, in particular:
> 
> 5) Never use the SET construct. SEQUENCE dos the job, is just fine.
> 
> 6) Always use simple (IMPLICIT) tags, and always use the CONTEXT
>    notation (or the 1994 default numbering feature, which is 
>    equivalent).
> 
> 7) Settle for exactly one notation of dates.
> 
> 8) Do the right thing with strings.  Do we really need more than
>    an octet string notation?  Should the character set used by an
>    application be checked by an interface stub?
> 
> Finally, the last recommendation would be to settle for exactly one
> binary representation.  DER comes to mind as the representation of
> choice --it is actually mandated for security applications.  If
> a comapct encoding is required, just run DER through a compression
> algorithm, e.g. gzip. This will compress the tags and extra zeroes,
> probably just like PER.  It will also compress the string values,
> something that PER does not.
> 
> Someone willing to write an ASN.1 profile for IETF standards ?
> 
> -- 
> Christian Huitema
> ----------
> See you at INET'98, Geneva 21-24,July 98 http://www.isoc.org/inet98/

---

From: [email-masked] (Christian Huitema)
Date: Mon, 5 Jan 1998 08:08:23 -0500 (EST)

XDR includes both an IDL and a coding spec.  Both could be used
instead of ASN.1, and are indeed used in many applications.